var InstaForex = {
	version: 0.1,
	items: [],
	selected: false,
	container: null,
	loader: null,
	timer: null,
	types: {
		forex: 'Forex News',
		prime: 'Prime News'
	},
	//server: 'http://iinstaforex.loc/' + language + '/gadget/news',
	server: 'https://www.instaforex.com/gadget/forex_news.php',
	config: {
		count: 3,
		language: language,
		type: 'all'
	},
	
	init: function() {
		var self = this;
		try {
			System.Gadget.Flyout.file = 'flyout.html';
			System.Gadget.settingsUI = 'settings.html';
			System.Gadget.Flyout.onHide = function() {
				self.selected = false;
			};
			System.Gadget.onSettingsClosed = function(event) {
				if (event.closeAction != event.Action.commit) {
					return;
				}
				self.config.count = System.Gadget.Settings.readString('count');
				self.config.type = System.Gadget.Settings.readString('type');
				self.update();
			};
		} catch (e) {}
		try {
			System.Gadget.Settings.writeString('count', this.config.count);
			System.Gadget.Settings.writeString('type', this.config.type);
		} catch (e) {}
		this.container = document.getElementById('container');
		this.loader = document.getElementById('loader');
		this.update();
	},
	
	addItem: function(item) {
		item.type = this.types[item.type];
		item.dom = $(this.Templating.render('item', item))[0];
		this.container.appendChild(item.dom);
		this.items.push(item);
	},
	
	getItem: function(id) {
		for (var i = 0, count = this.items.length; i < count; i++) {
			if (this.items[i].id == id) {
				return this.items[i];
			}
		}
		return false;
	},
	
	show: function(id) {
		var item = this.getItem(id);
		if (!item) {
			return;
		}
		if (this.selected === id) {
			this.selected = false;
			System.Gadget.Flyout.show = false;
		} else {
			if (this.selected) {
				System.Gadget.Flyout.document.getElementById('content').innerHTML = item.content;
				this.resize(System.Gadget.Flyout.document);
			} else {
				var self = this;
				System.Gadget.Flyout.onShow = function() {
					System.Gadget.Flyout.document.getElementById('content').innerHTML = item.content;
					self.resize(System.Gadget.Flyout.document);
				};
				System.Gadget.Flyout.show = true;
			}
			this.selected = id;
		}
	},
	
	update: function() {
		this.beforeUpdate();
		var self = this,
			ready = false;
		$.getJSON(this.server, this.config, function(response) {
			ready = true;
			if (response.error) {
				self.afterUpdate();
				return;
			}
			self.checkVersion(response.version);
			self.clear();
			for (var i = 0, count = response.items.length; i < count; i++) {
				if (self.items.length >= self.config.count) {
					break;
				}
				self.addItem(response.items[i]);
			}
			self.afterUpdate();
		});
		setTimeout(function() {
			if (ready) {
				return;
			}
			self.update();
		}, 10000);
	},
	
	beforeUpdate: function() {
		if (this.timer) {
			clearTimeout(this.timer);
		}
		this.loader.style.display = 'block';
		this.resize();
	},
	
	afterUpdate: function() {
		this.loader.style.display = 'none';
		this.resize();
		var self = this;
		this.timer = setTimeout(function() {
			self.update();
		}, 5 * 60 * 1000);
	},
	
	clear: function() {
		for (var i = 0, count = this.items.length; i < count; i++) {
			this.container.removeChild(this.items[i].dom);
		}
		this.items = [];
		//this.container.innerHTML = '';
	},
	
	resize: function(doc) {
		doc = doc || document
		var body = doc.getElementById('wrapper') || doc.getElementById('body');
		doc.body.style.width = body.offsetWidth + 'px';
		doc.body.style.height = body.offsetHeight + 'px';
	},
	
	checkVersion: function(version) {
		if (this.version == version) {
			return;
		}
		this.version = version;
		document.getElementById('version').style.display = 'block';
	}
};

InstaForex.Templating = {
	templates: {},
			  
	getTemplate: function(template) {
		var content = this.templates[template] || '';
		if (content) {
			return content;
		}
		var jsTemplate = $('script[data-template="' + template + '"]')[0];

		if (jsTemplate) {
			content = jsTemplate.innerHTML;
		}
		this.templates[template] = content;
		return content;
	},
	
	render: function(template, context) {
		context = context || {};
		var content = this.getTemplate(template);
		return this.fill(content, context);
	},
			  
	fill: function(content, context) {
		content = content || '';
		context = context || {};
		for (var i in context) {
			var regExp = new RegExp('{' + i + '}', 'g');
			content = content.replace(regExp, context[i]);
		}
		return content;
	}
};

InstaForex.Templating.templates.settings = '';

var IF = InstaForex;

$(document).ready(function() {
	InstaForex.resize();
	InstaForex.init();
});